/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.65 by cnh, Mon Feb 16 16:24:41 2004 UTC revision 1.81 by cnh, Wed Jun 30 00:58:06 2004 UTC
# Line 1  Line 1 
1  #! /usr/bin/env bash  #! /usr/bin/env sh
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 37  test_for_string_in_file() { Line 37  test_for_string_in_file() {
37      grep -i "$strng" $file > /dev/null 2>&1      grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo -n "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
41          grep -i "$strng" $file          grep -i "$strng" $file
42          return 1          return 1
43      fi      fi
# Line 67  expand_pkg_groups() { Line 67  expand_pkg_groups() {
67          done          done
68          PACKAGES=$new_packages          PACKAGES=$new_packages
69          rm -f ./p[1,2].tmp          rm -f ./p[1,2].tmp
70            return $matched
71      else      else
72          echo "Warning: can't read package groups definition file: $PKG_GROUPS"          echo "Warning: can't read package groups definition file: $PKG_GROUPS"
73      fi      fi
74  }  }
75    
76    #  Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
77    #  cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
78    check_for_broken_Ff()  {
79        #  Do we have defaults for $FS and/or $FS90 ?
80        tfs=f
81        tfs9=f90
82        if test "x$FS" != x ; then
83            tfs="$FS"
84        fi
85        if test "x$FS90" != x ; then
86            tfs9="$FS90"
87        fi
88    
89        #  First check the ability to create a *.F/.f pair.
90        cat <<EOF >> genmake_hello.F
91          program hello
92          write(*,*) 'hi'
93          stop
94          end
95    EOF
96        cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
97        RETVAL=$?
98        if test "x$RETVAL" != x0 ; then
99            if test "x$FS" = x ; then
100                FS='for'
101                FS90='fr9'
102                check_for_broken_Ff
103            else
104                cat <<EOF 2>&1
105    ERROR: Your file system cannot distinguish between *.F and *.f files
106      (fails the "cp" test) and this program cannot find a suitable
107      replacement extension.  Please try a different build environment or
108      contact the <MITgcm-support@mitgcm.org> list for help.
109    
110    EOF
111                exit -1
112            fi
113            return
114        fi
115        rm -f genmake_hello.*
116    
117        #  Check the ability of ${MAKE} and ${LN} to use the current set
118        #  of extensions.
119        cat <<EOF >> genmake_hello.F
120          program hello
121          write(*,*) 'hi'
122          stop
123          end
124    EOF
125        test -e Makefile  &&  mv -f Makefile Makefile.bak
126        cat <<EOF >> Makefile
127    %.$tfs : %.F
128    .SUFFIXES:
129    genmake_hello.$tfs: genmake_hello.F
130            $LN genmake_hello.F genmake_hello.$tfs
131    EOF
132        $MAKE "genmake_hello."$tfs > /dev/null 2>&1
133        RETVAL=$?
134        if test "x$RETVAL" != x0 -o ! -e "genmake_hello."$tfs ; then
135            if test "x$FS" = x ; then
136                FS='for'
137                FS90='fr9'
138                check_for_broken_Ff
139            else
140                cat <<EOF 2>&1
141    ERROR: Your file system cannot distinguish between *.F and *.f files
142      (fails the "make/ln" test) and this program cannot find a suitable
143      replacement extension.  Please try a different build environment or
144      contact the <MITgcm-support@mitgcm.org> list for help.
145    
146    EOF
147                exit -1
148                return
149            fi
150        fi
151        rm -f genmake_hello.* Makefile
152        test -e Makefile  &&  mv -f Makefile.bak Makefile
153    
154        #  If we make it here, use the extensions
155        FS=$tfs
156        FS90=$tfs9
157        return
158    }
159    
160    
161  # Guess possible config options for this host  # Guess possible config options for this host
162  find_possible_configs()  {  find_possible_configs()  {
163    
# Line 80  find_possible_configs()  { Line 166  find_possible_configs()  {
166      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
167      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
168      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
169      PLATFORM=$tmp2      tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
170        PLATFORM=$tmp3
171        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
172      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
173      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
174            
# Line 100  find_possible_configs()  { Line 188  find_possible_configs()  {
188          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
189      fi      fi
190    
191      # makedepend is not always available      #  The "original" makedepend is part of the Imake system that is
192        #  most often distributed with XFree86 or with an XFree86 source
193        #  package.  As a result, many machines (eg. generic Linux) do not
194        #  have a system-default "makedepend" available.  For those
195        #  systems, we have two fall-back options:
196        #
197        #    1) a makedepend implementation shipped with the cyrus-imapd
198        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
199        #
200        #    2) a known-buggy xmakedpend shell script
201        #
202        #  So the choices are, in order:
203        #
204        #    1) use the user-specified program
205        #    2) use a system-wide default
206        #    3) locally build and use the cyrus implementation
207        #    4) fall back to the buggy local xmakedpend script
208        #
209      if test "x${MAKEDEPEND}" = x ; then      if test "x${MAKEDEPEND}" = x ; then
210        which makedepend >& /dev/null        which makedepend > /dev/null 2>&1
211        RETVAL=$?        RV0=$?
212        if test "x${RETVAL}" = x1 ; then        cat <<EOF >> genmake_tc.f
213           echo "    makedepend was not found. Using xmakedpend instead."        program test
214           MAKEDEPEND='$(TOOLSDIR)/xmakedepend'        write(*,*) 'test'
215          stop
216          end
217    EOF
218          makedepend genmake_tc.f > /dev/null 2>&1
219          RV1=$?
220          if test ! "x${RV0}${RV1}" = x00 ; then
221             echo "    a system-default makedepend was not found."
222    
223             #  Try to build the cyrus impl
224             rm -f ./genmake_cy_md
225             (
226                 cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
227                     &&  ./configure > /dev/null 2>&1  \
228                     &&  make > /dev/null 2>&1
229                 if test -x ./makedepend.exe ; then
230                     $LN ./makedepend.exe ./makedepend
231                 fi
232                 ./makedepend ifparser.c > /dev/null 2>&1  \
233                     &&  echo "true"
234             ) > ./genmake_cy_md
235             grep true ./genmake_cy_md > /dev/null 2>&1
236             RETVAL=$?
237             if test "x$RETVAL" = x0 ; then
238                 MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
239             else
240                 MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
241             fi
242             rm -f ./genmake_cy_md
243        fi        fi
244      fi      fi
245    
# Line 145  EOF Line 278  EOF
278          echo "   "$p_FC          echo "   "$p_FC
279          if test "x$FC" = x ; then          if test "x$FC" = x ; then
280              FC=`echo $p_FC | $AWK '{print $1}'`              FC=`echo $p_FC | $AWK '{print $1}'`
281                echo "  Setting FORTRAN compiler to: "$FC
282          fi          fi
283      fi      fi
284    
285      for i in $p_FC ; do      if test "x$OPTFILE" = x ; then
286          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i          OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
287          if test -r $p_OF ; then          if test ! -r $OPTFILE ; then
288              OPTFILE=$p_OF               echo "  I looked for the file "$OPTFILE" but did not find it"
289              echo "  The options file:  $p_OF"          fi
290              echo "    appears to match so we'll use it."      fi
291              break  #    echo "  The options file:  $p_OF"
292          fi  #    echo "    appears to match so we'll use it."
293      done  #   for i in $p_FC ; do
294    #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
295    #if test -r $p_OF ; then
296    #    OPTFILE=$p_OF
297    #    echo "  The options file:  $p_OF"
298    #    echo "    appears to match so we'll use it."
299    #    break
300    #fi
301    #   done
302      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
303          cat 1>&2 <<EOF          cat 1>&2 <<EOF
304    
# Line 215  get_pdepend_list()  { Line 357  get_pdepend_list()  {
357      . ./.pd_tmp      . ./.pd_tmp
358      rm -f ./.pd_tmp      rm -f ./.pd_tmp
359    
360      echo -n "PNAME = "${}      printf "PNAME = "${}
361  }  }
362    
363    
# Line 229  Usage: "$0" [OPTIONS] Line 371  Usage: "$0" [OPTIONS]
371      -help | --help | -h | --h      -help | --help | -h | --h
372            Print this help message and exit.            Print this help message and exit.
373    
374        -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
375          -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
376              Use "NAME" as the adoptfile.  By default, the file at
377              "tools/adjoint_options/adjoint_default" will be used.
378    
379      -nooptfile | --nooptfile      -nooptfile | --nooptfile
380        -optfile NAME | --optfile NAME | -of NAME | --of NAME        -optfile NAME | --optfile NAME | -of NAME | --of NAME
381        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
# Line 253  Usage: "$0" [OPTIONS] Line 400  Usage: "$0" [OPTIONS]
400        --makefile=NAME | -mf=NAME        --makefile=NAME | -mf=NAME
401            Call the makefile "NAME".  The default is "Makefile".            Call the makefile "NAME".  The default is "Makefile".
402    
403        -makedepend NAME | -md NAME
404          --makedepend=NAME | -md=NAME
405              Use "NAME" for the MAKEDEPEND program.
406    
407      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
408        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
409            Specify the location of the MITgcm ROOTDIR as "NAME".            Specify the location of the MITgcm ROOTDIR as "NAME".
# Line 294  Usage: "$0" [OPTIONS] Line 445  Usage: "$0" [OPTIONS]
445            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
446            is being used.            is being used.
447    
448        -mpi | --mpi
449              Include MPI header files and link to MPI libraries
450        -mpi=PATH | --mpi=PATH
451              Include MPI header files and link to MPI libraries using MPI_ROOT
452              set to PATH. i.e. Include files from $PATH/include, link to libraries
453              from $PATH/lib and use binaries from $PATH/bin.
454    
455        -bash NAME
456              Explicitly specify the Bourne or BASH shell to use
457    
458    While it is most often a single word, the "NAME" variables specified    While it is most often a single word, the "NAME" variables specified
459    above can in many cases be a space-delimited string such as:    above can in many cases be a space-delimited string such as:
460    
# Line 438  EOF Line 599  EOF
599    
600    
601  check_netcdf_libs()  {  check_netcdf_libs()  {
602      cat <<EOF > genmake_tnc.F      cat <<EOF > genmake_tnc.for
603        program fgennc        program fgennc
604  #include "netcdf.inc"  #include "netcdf.inc"
605        integer iret, ncid, xid        integer iret, ncid, xid
# Line 450  check_netcdf_libs()  { Line 611  check_netcdf_libs()  {
611        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
612        end        end
613  EOF  EOF
614      $CPP genmake_tnc.F > genmake_tnc.f  \      $CPP genmake_tnc.for > genmake_tnc.f  \
615          &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1          &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1
616      RET_COMPILE=$?      RET_COMPILE=$?
617      test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1      test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
# Line 458  EOF Line 619  EOF
619      if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then      if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
620          HAVE_NETCDF=t          HAVE_NETCDF=t
621      else      else
622          cat genmake_tnc.log >> genmake_warnings          # try again with "-lnetcdf" added to the libs
623            $CPP genmake_tnc.for > genmake_tnc.f  \
624                &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \
625                $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1
626            RET_COMPILE=$?
627            test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
628            RETVAL=$?
629            if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
630                LIBS="$LIBS -lnetcdf"
631                HAVE_NETCDF=t
632            else
633                cat genmake_tnc.log >> genmake_warnings
634            fi
635      fi      fi
636      rm -f genmake_tnc*      rm -f genmake_tnc*
637  }  }
638    
639    
640    
641    ###############################################################################
642    #   Sequential part of script starts here
643    ###############################################################################
644    
645  #  Set defaults here  #  Set defaults here
646  COMMANDL="$0 $@"  COMMANDL="$0 $@"
647    
# Line 474  KPP= Line 652  KPP=
652  FC=  FC=
653  CPP=  CPP=
654  LINK=  LINK=
 # DEFINES="-DWORDLENGTH=4"  
655  DEFINES=  DEFINES=
656  PACKAGES=  PACKAGES=
657  ENABLE=  ENABLE=
# Line 491  FOPTIM= Line 668  FOPTIM=
668  CFLAGS=  CFLAGS=
669  KFLAGS1=  KFLAGS1=
670  KFLAGS2=  KFLAGS2=
671    #LDADD=
672  LIBS=  LIBS=
673  KPPFILES=  KPPFILES=
674  NOOPTFILES=  NOOPTFILES=
675  NOOPTFLAGS=  NOOPTFLAGS=
676    MPI=
677    MPIPATH=
678    
679  # DEFINES checked by test compilation  # DEFINES checked by test compilation
680  HAVE_SYSTEM=  HAVE_SYSTEM=
# Line 502  HAVE_FDATE= Line 682  HAVE_FDATE=
682  FC_NAMEMANGLE=  FC_NAMEMANGLE=
683  HAVE_CLOC=  HAVE_CLOC=
684  HAVE_NETCDF=  HAVE_NETCDF=
685    HAVE_ETIME=
686    
687  MODS=  MODS=
688  TOOLSDIR=  TOOLSDIR=
# Line 509  SOURCEDIRS= Line 690  SOURCEDIRS=
690  INCLUDEDIRS=  INCLUDEDIRS=
691  STANDARDDIRS="USE_THE_DEFAULT"  STANDARDDIRS="USE_THE_DEFAULT"
692    
693    G2ARGS=
694    BASH=
695  PWD=`pwd`  PWD=`pwd`
696  MAKE=make  MAKE=make
697  AWK=awk  AWK=awk
# Line 524  IEEE= Line 707  IEEE=
707  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
708      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
709  fi  fi
710    FS=
711    FS90=
712    
713  AUTODIFF_PKG_USED=f  AUTODIFF_PKG_USED=f
714  AD_OPTFILE=  AD_OPTFILE=
# Line 548  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPE Line 733  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPE
733  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
734  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
735  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
736  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
737    
738  #  The following are all related to adjoint/tangent-linear stuff  #  The following are all related to adjoint/tangent-linear stuff
739  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
# Line 577  for i in . $MODS ; do Line 762  for i in . $MODS ; do
762          break          break
763      fi      fi
764  done  done
765  echo -n "  getting local config information:  "  printf "  getting local config information:  "
766  if test -e $gm_local ; then  if test -e $gm_local ; then
767      echo "using $gm_local"      echo "using $gm_local"
768      . $gm_local      . $gm_local
# Line 601  fi Line 786  fi
786  ac_prev=  ac_prev=
787  for ac_option ; do  for ac_option ; do
788    
789        G2ARGS="$G2ARGS \"$ac_option\""
790    
791      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
792      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
793          eval "$ac_prev=\$ac_option"          eval "$ac_prev=\$ac_option"
# Line 642  for ac_option ; do Line 829  for ac_option ; do
829          -make=* | --make=* | -m=* | --m=*)          -make=* | --make=* | -m=* | --m=*)
830              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
831                    
832            -bash | --bash)
833                ac_prev=BASH ;;
834            -bash=* | --bash=*)
835                BASH=$ac_optarg ;;
836            
837            -makedepend | --makedepend | -md | --md)
838                ac_prev=MAKEDEPEND ;;
839            -makedepend=* | --makedepend=* | -md=* | --md=*)
840                MAKEDEPEND=$ac_optarg ;;
841            
842          -makefile | --makefile | -ma | --ma)          -makefile | --makefile | -ma | --ma)
843              ac_prev=MAKEFILE ;;              ac_prev=MAKEFILE ;;
844          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
# Line 689  for ac_option ; do Line 886  for ac_option ; do
886          -fc=* | --fc=*)          -fc=* | --fc=*)
887              FC=$ac_optarg ;;              FC=$ac_optarg ;;
888                    
889            -fs | --fs)
890                ac_prev=FS ;;
891            -fs=* | --fs=*)
892                FS=$ac_optarg ;;
893            
894            -fs90 | --fs90)
895                ac_prev=FS90 ;;
896            -fs90=* | --fs90=*)
897                FS90=$ac_optarg ;;
898            
899          -ieee | --ieee)          -ieee | --ieee)
900              IEEE=true ;;              IEEE=true ;;
901          -noieee | --noieee)          -noieee | --noieee)
902              IEEE= ;;              IEEE= ;;
903    
904            -mpi | --mpi)
905                MPI=true ;;
906            -mpi=* | --mpi=*)
907                MPIPATH=$ac_optarg
908                MPI=true ;;
909                    
910  #       -jam | --jam)  #       -jam | --jam)
911  #           JAM=1 ;;  #           JAM=1 ;;
# Line 745  if test "x${ROOTDIR}" = x ; then Line 958  if test "x${ROOTDIR}" = x ; then
958          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
959              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
960                  ROOTDIR=$d                  ROOTDIR=$d
961                  echo -n "Warning:  ROOTDIR was not specified but there appears to be"                  printf "Warning:  ROOTDIR was not specified but there appears to be"
962                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
963                  break                  break
964              fi              fi
# Line 779  if test "x$OPTFILE" != xNONE ; then Line 992  if test "x$OPTFILE" != xNONE ; then
992          . "$OPTFILE"          . "$OPTFILE"
993          RETVAL=$?          RETVAL=$?
994          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
995              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              printf "Error: failed to source OPTFILE \"$OPTFILE\""
996              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
997              exit 1              exit 1
998          fi          fi
# Line 792  if test "x$OPTFILE" != xNONE ; then Line 1005  if test "x$OPTFILE" != xNONE ; then
1005      fi      fi
1006  fi  fi
1007    
1008    #  Check for broken systems that cannot correctly distinguish *.F and *.f files
1009    # check_for_broken_Ff
1010    
1011  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1012  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1013      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 806  if test "x${AD_OPTFILE}" != xNONE ; then Line 1022  if test "x${AD_OPTFILE}" != xNONE ; then
1022          . "$AD_OPTFILE"          . "$AD_OPTFILE"
1023          RETVAL=$?          RETVAL=$?
1024          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1025              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1026              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1027              exit 1              exit 1
1028          fi          fi
# Line 821  fi Line 1037  fi
1037    
1038  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1039  #  either set defaults or complain and abort!  #  either set defaults or complain and abort!
1040    if test ! "x$BASH" = x ; then
1041        # add a trailing space so that it works within the Makefile syntax (see below)
1042        BASH="$BASH "
1043    fi
1044  if test "x$FC" = x ; then  if test "x$FC" = x ; then
1045      cat <<EOF 1>&2      cat <<EOF 1>&2
1046    
# Line 841  if test "x$CPP" = x ; then Line 1061  if test "x$CPP" = x ; then
1061      CPP=cpp      CPP=cpp
1062  fi  fi
1063  #EH3 === UGLY ===  #EH3 === UGLY ===
1064  #  The following an ugly little hack to check for $CPP in /lib/ and it  #  The following is an ugly little hack to check for $CPP in /lib/ and
1065  #  should eventually be replaced with a more general function that  #  it should eventually be replaced with a more general function that
1066  #  searches a combo of the user's path and a list of "usual suspects"  #  searches a combo of the user's path and a list of "usual suspects"
1067  #  to find the correct location for binaries such as $CPP.  #  to find the correct location for binaries such as $CPP.
1068  for i in " " "/lib/" ; do  for i in " " "/lib/" ; do
# Line 885  EOF Line 1105  EOF
1105  fi  fi
1106  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1107    
1108    #  Check for broken *.F/*.f handling and fix if possible
1109    check_for_broken_Ff
1110    
1111    if test ! "x$MPI" = x ; then
1112          echo "  Turning on MPI cpp macros"
1113          DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1114    fi
1115    
1116  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
1117  echo -n "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
1118  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1119        program hello        program hello
1120        call system('echo hi')        call system('echo hi')
# Line 905  else Line 1132  else
1132  fi  fi
1133  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1134    
1135  echo -n "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1136  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1137        program hello        program hello
1138        CHARACTER(128) string        CHARACTER(128) string
# Line 926  else Line 1153  else
1153  fi  fi
1154  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1155    
1156  echo -n "  Can we call simple C routines (here, \"cloc()\") using $FC...  "  printf "  Do we have the etime() command using $FC...  "
1157    cat > genmake_tcomp.f <<EOF
1158          program hello
1159          REAL*4 TARRAY(2)
1160          call etime( tarray )
1161          print *, tarray
1162          end
1163    EOF
1164    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1165    RETVAL=$?
1166    if test "x$RETVAL" = x0 ; then
1167        HAVE_ETIME=t
1168        DEFINES="$DEFINES -DHAVE_ETIME"
1169        echo "yes"
1170    else
1171        HAVE_ETIME=
1172        echo "no"
1173    fi
1174    rm -f genmake_tcomp*
1175    
1176    printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1177  check_HAVE_CLOC  check_HAVE_CLOC
1178  if test "x$HAVE_CLOC" != x ; then  if test "x$HAVE_CLOC" != x ; then
1179      echo "yes"      echo "yes"
# Line 935  else Line 1182  else
1182  fi  fi
1183  rm -f genmake_t*  rm -f genmake_t*
1184    
1185  echo -n "  Can we create NetCDF-enabled binaries...  "  printf "  Can we create NetCDF-enabled binaries...  "
1186  check_netcdf_libs  check_netcdf_libs
1187  if test "x$HAVE_NETCDF" != x ; then  if test "x$HAVE_NETCDF" != x ; then
1188      echo "yes"      echo "yes"
# Line 945  fi Line 1192  fi
1192    
1193    
1194  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1195  echo -n "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1196  for d in $MODS ; do  for d in $MODS ; do
1197      if test ! -d $d ; then      if test ! -d $d ; then
1198          echo          echo
1199          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1200          exit 1          exit 1
1201      else      else
1202          echo -n " $d"          printf " $d"
1203          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1204          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1205      fi      fi
# Line 1077  else Line 1324  else
1324          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1325          RETVAL=$?          RETVAL=$?
1326          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1327              echo -n "Error: can't parse default package list "              printf "Error: can't parse default package list "
1328              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PDEFAULT=\"$PDEFAULT\""
1329              exit 1              exit 1
1330          fi          fi
# Line 1085  else Line 1332  else
1332              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1333          done          done
1334          echo "    before group expansion packages are: $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1335          expand_pkg_groups          while ! expand_pkg_groups; do echo > /dev/null; done
1336          echo "    after group expansion packages are:  $PACKAGES"          echo "    after group expansion packages are:  $PACKAGES"
1337      fi      fi
1338  fi  fi
1339    
1340  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1341    for i in $PACKAGES ; do
1342        echo $i >> ./.tmp_pack
1343    done
1344    for i in `grep  "-" ./.tmp_pack` ; do
1345        j=`echo $i | sed 's/[-]//'`
1346        DISABLE="$DISABLE $j"
1347    done
1348  pack=  pack=
1349  for p in $PACKAGES ; do  for p in $PACKAGES ; do
1350      addit="t"      addit="t"
# Line 1107  PACKAGES="$pack" Line 1361  PACKAGES="$pack"
1361  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1362  echo "" > ./.tmp_pack  echo "" > ./.tmp_pack
1363  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1364    # Test if each explicitly referenced package exists
1365  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1366      if test ! -d "$ROOTDIR/pkg/$i" ; then      j=`echo $i | sed 's/[-+]//'`
1367        if test ! -d "$ROOTDIR/pkg/$j" ; then
1368          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1369          exit 1          exit 1
1370      fi      fi
1371      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
1372  done  done
 pack=`cat ./.tmp_pack | sort | uniq`  
 rm -f ./.tmp_pack  
1373  PACKAGES=  PACKAGES=
1374  for i in $pack ; do  for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1375      PACKAGES="$PACKAGES $i"      PACKAGES="$PACKAGES $i"
1376  done  done
1377    rm -f ./.tmp_pack
1378  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1379    
1380  echo "  applying package dependency rules"  echo "  applying package dependency rules"
# Line 1360  rm -rf .links.tmp Line 1615  rm -rf .links.tmp
1615  mkdir .links.tmp  mkdir .links.tmp
1616  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
1617  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
1618  echo -n 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
1619  echo -n 'CSRCFILES = '   > csrclist.inc  printf 'CSRCFILES = '   > csrclist.inc
1620  echo -n 'F90SRCFILES = ' > f90srclist.inc  printf 'F90SRCFILES = ' > f90srclist.inc
1621  echo -n 'HEADERFILES = ' > hlist.inc  printf 'HEADERFILES = ' > hlist.inc
1622  echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
1623  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1624  for d in $alldirs ; do  for d in $alldirs ; do
1625      deplist=      deplist=
# Line 1389  for d in $alldirs ; do Line 1644  for d in $alldirs ; do
1644                  case $extn in                  case $extn in
1645                      F)                      F)
1646                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
1647                          echo -n " $sf" >> srclist.inc                          printf " $sf" >> srclist.inc
1648                          ;;                          ;;
1649                      F90)                      F90)
1650                          echo    " \\"  >> f90srclist.inc                          echo    " \\"  >> f90srclist.inc
1651                          echo -n " $sf" >> f90srclist.inc                          printf " $sf" >> f90srclist.inc
1652                          ;;                          ;;
1653                      c)                      c)
1654                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.inc
1655                          echo -n " $sf" >> csrclist.inc                          printf " $sf" >> csrclist.inc
1656                          ;;                          ;;
1657                      h)                      h)
1658                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1659                          echo -n " $sf" >> hlist.inc                          printf " $sf" >> hlist.inc
1660                          ;;                          ;;
1661                      flow)                      flow)
1662                          echo    " \\"  >> ad_flow_files.inc                          echo    " \\"  >> ad_flow_files.inc
1663                          echo -n " $sf" >> ad_flow_files.inc                          printf " $sf" >> ad_flow_files.inc
1664                          ;;                          ;;
1665                  esac                  esac
1666              fi              fi
# Line 1434  echo "#    $MACHINE" >> $MAKEFILE Line 1689  echo "#    $MACHINE" >> $MAKEFILE
1689  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
1690  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
1691  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
1692  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
1693  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1694  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE
1695    
# Line 1502  FC = ${FC} Line 1757  FC = ${FC}
1757  # Fortran compiler  # Fortran compiler
1758  F90C = ${F90C}  F90C = ${F90C}
1759  # Link editor  # Link editor
1760  LINK = ${LINK}  LINK = ${LINK} ${LDADD}
1761    
1762  # Defines for CPP  # Defines for CPP
1763  DEFINES = ${DEFINES}  DEFINES = ${DEFINES}
# Line 1534  cat csrclist.inc      >> $MAKEFILE Line 1789  cat csrclist.inc      >> $MAKEFILE
1789  cat f90srclist.inc    >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1790  cat hlist.inc         >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1791  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
1792  echo               >> $MAKEFILE  echo >> $MAKEFILE
1793  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
1794  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE
1795  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1796    echo >> $MAKEFILE
1797    echo '.SUFFIXES:' >> $MAKEFILE
1798    echo '.SUFFIXES: .o .F .p .'$FS' .c .F90 .'$FS90 >> $MAKEFILE
1799  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1800  rm -f ad_flow_files.inc  rm -f ad_flow_files.inc
1801    
1802  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1803    
 .SUFFIXES:  
 .SUFFIXES: .o .f .p .F .c .F90 .f90  
   
1804  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1805  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1806          @echo Creating \$@ ...          @echo Creating \$@ ...
1807          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1808  depend:  depend:
1809          @make links          @make links
1810          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1811          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1812            -rm -f makedepend.out
1813    
1814  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1815    
# Line 1565  output.txt: \$(EXECUTABLE) Line 1820  output.txt: \$(EXECUTABLE)
1820          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1821    
1822  clean:  clean:
1823          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
1824  Clean:  Clean:
1825          @make clean          @make clean
1826          @make cleanlinks          @make cleanlinks
# Line 1576  CLEAN: Line 1831  CLEAN:
1831          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1832          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1833          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1834          -rm -f \$(EXECUTABLE) output.txt          -rm -f \$(EXECUTABLE) output.txt STD*
1835    
1836  #eh3 Makefile: makefile  #eh3 Makefile: makefile
1837  makefile:  makefile:
1838          $THIS_SCRIPT $@          $THIS_SCRIPT $G2ARGS
1839  cleanlinks:  cleanlinks:
1840          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1841    
1842  # Special targets ($SPECIAL_FILES) which are create by make  # Special targets ($SPECIAL_FILES) which are create by make
1843  ${PACKAGES_DOT_H}:  ${PACKAGES_DOT_H}:
1844          @echo Creating \$@ ...          @echo Creating \$@ ...
1845          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1846  AD_CONFIG.h:  AD_CONFIG.h:
1847          @echo Creating \$@ ...          @echo Creating \$@ ...
1848          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1849  FC_NAMEMANGLE.h:  FC_NAMEMANGLE.h:
1850          @echo Creating \$@ ...          @echo Creating \$@ ...
1851          echo "$FC_NAMEMANGLE" > \$@          echo "$FC_NAMEMANGLE" > \$@
1852    
1853  # The normal chain of rules is (  .F - .f - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
1854  .F.f:  
1855    %.o : %.F
1856    
1857    .F.$FS:
1858          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1859  .f.o:  .$FS.o:
1860          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
1861  .F90.f90:  .F90.$FS90:
1862          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1863  .f90.o:  .$FS90.o:
1864          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
1865  .c.o:  .c.o:
1866          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) -c \$<
1867    
1868  # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
1869  .F.p:  .F.p:
1870          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1871  .p.f:  .p.$FS:
1872          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1873    
1874  #=========================================  #=========================================
# Line 1637  done Line 1895  done
1895    
1896  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
1897  echo >> $MAKEFILE  echo >> $MAKEFILE
1898  echo -n "AD_FILES = " >> $MAKEFILE  printf "AD_FILES = " >> $MAKEFILE
1899  AD_FILES=`cat ad_files`  AD_FILES=`cat ad_files`
1900  for i in $AD_FILES ; do  for i in $AD_FILES ; do
1901      echo    " \\" >> $MAKEFILE      echo    " \\" >> $MAKEFILE
1902      echo -n " $i" >> $MAKEFILE      printf " $i" >> $MAKEFILE
1903  done  done
1904  echo >> $MAKEFILE  echo >> $MAKEFILE
1905  rm -f ad_files  rm -f ad_files
# Line 1654  adtaf: ad_taf_output.f Line 1912  adtaf: ad_taf_output.f
1912  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.f
1913    
1914  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1915          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
1916          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1917          -rm -f ad_config.template          -rm -f ad_config.template
1918          @make \$(F77FILES)          @make \$(F77FILES)
# Line 1686  ftltaf: ftl_taf_output.f Line 1944  ftltaf: ftl_taf_output.f
1944  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.f
1945    
1946  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1947          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
1948          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1949          -rm -f ftl_config.template          -rm -f ftl_config.template
1950          @make \$(F77FILES)          @make \$(F77FILES)
# Line 1735  for i in $KPPFILES ; do Line 1993  for i in $KPPFILES ; do
1993      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
1994          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
1995      fi      fi
1996      echo "$base.f: $base.p" >> $MAKEFILE      echo "$base.$FS: $base.p" >> $MAKEFILE
1997  done  done
1998    
1999  echo "  Making list of NOOPTFILES"  echo "  Making list of NOOPTFILES"
# Line 1745  for i in $NOOPTFILES ; do Line 2003  for i in $NOOPTFILES ; do
2003      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2004          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2005      fi      fi
2006      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.$FS" >> $MAKEFILE
2007      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2008  done  done
2009    
# Line 1759  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 2017  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
2017  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
2018    
2019  # Create special header files  # Create special header files
2020  $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"  $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
2021  if test ! -f $PACKAGES_DOT_H ; then  if test ! -f $PACKAGES_DOT_H ; then
2022      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2023  else  else
# Line 1773  else Line 2031  else
2031      fi      fi
2032  fi  fi
2033  if test ! -f AD_CONFIG.h ; then  if test ! -f AD_CONFIG.h ; then
2034      $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h      $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
2035  fi  fi
2036    
2037    
2038  #  Write the "state" for future records  #  Write the "state" for future records
2039  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
2040      echo -n "" > genmake_state      printf "" > genmake_state
2041      for i in $gm_state ; do      for i in $gm_state ; do
2042          t1="t2=\$$i"          t1="t2=\$$i"
2043          eval $t1          eval $t1

Legend:
Removed from v.1.65  
changed lines
  Added in v.1.81

  ViewVC Help
Powered by ViewVC 1.1.22